Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.iter
Class ListIterator<T extends Item>

    java.lang.Object
      net.sf.saxon.tree.iter.ListIterator<T>

All Implemented Interfaces:
  LastPositionFinder<T>, SequenceIterator<T>, GroundedIterator<T>, LookaheadIterator<T>, UnfailingIterator<T>

    public class ListIterator<T extends Item>

extends Object
implements UnfailingIterator<T>, LastPositionFinder<T>, LookaheadIterator<T>, GroundedIterator<T>

Class ListIterator, iterates over a sequence of items held in a Java List

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`ListIterator(List<T> list)` Create a ListIterator over a given List
`ListIterator(List<T> list, int length)` Create a ListIterator over the leading part of a given List

Method Summary
`void` | `close()` Close the iterator.
`T` | `current()` Get the current item in the sequence.
`ListIterator<T>` | `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence.
`int` | `getLength()` Get the last position (that is, the number of items in the sequence).
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`boolean` | `hasNext()` Determine whether there are more items to come.
`GroundedValue<T>` | `materialize()` Return a SequenceValue containing all the items in the sequence returned by this SequenceIterator
`T` | `next()` Get the next item in the sequence.
`int` | `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ListIterator

    public ListIterator(List<T> list)

  Create a ListIterator over a given List

  Parameters:
    `list` - the list: all objects in the list must be instances of `Item`

### ListIterator

    public ListIterator(List<T> list,
                        int length)

  Create a ListIterator over the leading part of a given List

  Parameters:
    `list` - the list: all objects in the list must be instances of `Item`
    `length` - the number of items to be included

Method Detail

### hasNext

    public boolean hasNext()

  Description copied from interface: `LookaheadIterator`
  Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

  This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LOOKAHEAD`

  Specified by:
    `hasNext` in interface `LookaheadIterator<T extends Item>`
  Returns:
    true if there are more items in the sequence

### next

    public T next()

  Description copied from interface: `UnfailingIterator`
  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator<T extends Item>`
  Specified by:
    `next` in interface `UnfailingIterator<T extends Item>`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public T current()

  Description copied from interface: `UnfailingIterator`
  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator<T extends Item>`
  Specified by:
    `current` in interface `UnfailingIterator<T extends Item>`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Description copied from interface: `UnfailingIterator`
  Get the current position

  Specified by:
    `position` in interface `SequenceIterator<T extends Item>`
  Specified by:
    `position` in interface `UnfailingIterator<T extends Item>`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator<T extends Item>`

### getLength

    public int getLength()

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLength` in interface `LastPositionFinder<T extends Item>`
  Returns:
    the number of items in the sequence

### getAnother

    public ListIterator<T> getAnother()

  Description copied from interface: `UnfailingIterator`
  Get another iterator over the same sequence of items, positioned at the start of the sequence. It must be possible to call this method at any time, whether none, some, or all of the items in the original iterator have been read. The method is non-destructive: it does not change the state of the original iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator<T extends Item>`
  Specified by:
    `getAnother` in interface `UnfailingIterator<T extends Item>`
  Returns:
    a new iterator over the same sequence

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator<T extends Item>`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### materialize

    public GroundedValue<T> materialize()

  Return a SequenceValue containing all the items in the sequence returned by this SequenceIterator

  Specified by:
    `materialize` in interface `GroundedIterator<T extends Item>`
  Returns:
    the corresponding SequenceValue

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.